package esercitazione2.queues;

import java.util.Arrays;

public class Queue<T> {

	private T[] values;
	private Integer length;
	private Integer head;
	private Integer maxLength;
	
	public Queue(Integer maxLength) {
	
		this.maxLength = maxLength;
		this.head = 0;
		this.length = 0;
		this.values = (T[]) new Object[maxLength];
		
	}

    public void enque(T item){
    	

    	this.values[(head + length) % maxLength] = item;
    	this.length++;    	
    }
	
    
    public T dequeue(){
    	
    	T tmp = this.values[this.head];
    	
    	this.head = (this.head + 1) % this.maxLength;
    	
    	this.length--;
    	
    	return tmp;
    }
    
    public String fullArrayToString(){
    	
    	return Arrays.toString(this.values);
    	
    }
	
    public String toString(){
		
		String s = "";
		
		for (int i = 0; i < this.length; i++) {
			s = s + this.values[(this.head + i) % this.maxLength] + " ";
		}

		return s;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Queue<Integer> q = new Queue<Integer>(10);
		
		q.enque(10);
		q.enque(12);
		q.enque(15);
		q.enque(16);
		
		System.out.println("\n" + q.fullArrayToString() + "\nhead: " + q.head + "\nlength: " + q.length);
		System.out.println("\n" + q.toString());
		
		q.dequeue();
		q.dequeue();
		
		System.out.println("\n" + q.fullArrayToString() + "\nhead: " + q.head + "\nlength: " + q.length);
		System.out.println("\n" + q.toString());
	}

}
